Large Dataset Downsampling in JavaScript

Using ApexCharts with JavaScript

This Large Dataset Downsampling example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var TOTAL_POINTS = 500000

function generateData(count) {
  var data = new Array(count)
  var startTime = new Date('2010-01-01T00:00:00Z').getTime()
  var step = 60 * 1000 // 1 minute
  var y = 100
  for (var i = 0; i < count; i++) {
    // Random walk with periodic components — gives visible structure at
    // multiple zoom levels (slow trend + faster cycle + noise).
    y +=
      (Math.random() - 0.5) * 2 +
      Math.sin(i / 5000) * 0.05 +
      Math.cos(i / 1200) * 0.02
    data[i] = [startTime + i * step, +y.toFixed(3)]
  }
  return data
}

var seriesData = generateData(TOTAL_POINTS)
var lastRenderMs = 0
var lastZoomLabel = 'full range'

function fmt(ts) {
  var d = new Date(ts)
  return (
    d.getFullYear() +
    '-' +
    String(d.getMonth() + 1).padStart(2, '0') +
    '-' +
    String(d.getDate()).padStart(2, '0')
  )
}

// Accepts the live chart instance as an argument so the React and Vue builds
// (which have no global `chart` var) can share this stateless helper.
function updateStats(chart) {
  var statsEl = document.getElementById('stats')
  if (!statsEl || !chart || !chart.w) return
  var drawn = (chart.w.globals.series[0] || []).length
  statsEl.innerHTML =
    'Raw points: <b>' +
    TOTAL_POINTS.toLocaleString() +
    '</b> &nbsp;·&nbsp; Currently drawn: <b>' +
    drawn.toLocaleString() +
    '</b> &nbsp;·&nbsp; Window: <b>' +
    lastZoomLabel +
    '</b> &nbsp;·&nbsp; Render: <b>' +
    lastRenderMs +
    ' ms</b>'
}

var options = {
  series: [{ name: 'Sensor reading', data: seriesData }],
  chart: {
    height: 460,
    type: 'line',
    animations: { enabled: false },
    zoom: { enabled: true, type: 'x', autoScaleYaxis: true },
    toolbar: { autoSelected: 'zoom' },
    dataReducer: {
      enabled: true,
      algorithm: 'lttb',
      targetPoints: 500,
      threshold: 1000,
    },
    events: {
      zoomed: function (chartCtx, args) {
        var xaxis = args && args.xaxis
        lastZoomLabel =
          xaxis && xaxis.min && xaxis.max
            ? fmt(xaxis.min) + ' → ' + fmt(xaxis.max)
            : 'full range'
        requestAnimationFrame(function () {
          updateStats(chartCtx)
        })
      },
      beforeResetZoom: function () {
        lastZoomLabel = 'full range'
      },
    },
  },
  stroke: { curve: 'straight', width: 1 },
  dataLabels: { enabled: false },
  markers: { size: 0 },
  title: {
    text: 'Line chart — 500,000 raw datapoints',
    align: 'left',
  },
  subtitle: {
    text: 'LTTB downsampling enabled — zoom in to re-sample the raw series at higher resolution within the visible window',
    align: 'left',
  },
  xaxis: {
    type: 'datetime',
    labels: { datetimeUTC: false },
  },
  yaxis: {
    labels: {
      formatter: function (val) {
        return val.toFixed(2)
      },
    },
  },
  tooltip: { x: { format: 'yyyy-MM-dd HH:mm' } },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

// Initial render is started by the template above; wait one frame and update
// stats once the chart instance has finished its first paint.
requestAnimationFrame(function poll() {
  if (chart.w && chart.w.globals && chart.w.globals.series) {
    updateStats(chart)
  } else {
    requestAnimationFrame(poll)
  }
})

function rebuild() {
  var enabled = document.getElementById('toggleReducer').checked
  var targetPoints = parseInt(document.getElementById('targetPoints').value, 10)

  options.chart.dataReducer.enabled = enabled
  options.chart.dataReducer.targetPoints = targetPoints
  options.subtitle.text = enabled
    ? 'LTTB downsampling enabled — drawing ~' +
      targetPoints.toLocaleString() +
      ' points'
    : 'Downsampling disabled — drawing every raw point'

  var t2 = performance.now()
  chart.destroy()
  chart = new ApexCharts(document.querySelector('#chart'), options)
  chart.render().then(function () {
    lastRenderMs = Math.round(performance.now() - t2)
    updateStats(chart)
  })
}

document.getElementById('rerender').addEventListener('click', rebuild)
document.getElementById('toggleReducer').addEventListener('change', rebuild)
document.getElementById('resetZoom').addEventListener('click', function () {
  if (chart) chart.resetSeries(true, true)
})

Large Dataset Downsampling in Angular

Using ApexCharts with Angular

This Large Dataset Downsampling example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private TOTAL_POINTS: any = 500000;

  private generateData = (count: any): any => {
          var data = new Array(count)
          var startTime = new Date('2010-01-01T00:00:00Z').getTime()
          var step = 60 * 1000 // 1 minute
          var y = 100
          for (var i = 0; i < count; i++) {
            // Random walk with periodic components — gives visible structure at
            // multiple zoom levels (slow trend + faster cycle + noise).
            y +=
              (Math.random() - 0.5) * 2 +
              Math.sin(i / 5000) * 0.05 +
              Math.cos(i / 1200) * 0.02
            data[i] = [startTime + i * step, +y.toFixed(3)]
          }
          return data
        };

  private seriesData: any = this.generateData(this.TOTAL_POINTS);

  private lastRenderMs: any = 0;

  private lastZoomLabel: any = 'full range';

  private fmt = (ts: any): any => {
          var d = new Date(ts)
          return (
            d.getFullYear() +
            '-' +
            String(d.getMonth() + 1).padStart(2, '0') +
            '-' +
            String(d.getDate()).padStart(2, '0')
          )
        };

  private updateStats = (chart: any): any => {
          var statsEl = document.getElementById('stats')
          if (!statsEl || !chart || !chart.w) return
          var drawn = (chart.w.globals.series[0] || []).length
          statsEl.innerHTML =
            'Raw points: <b>' +
            this.TOTAL_POINTS.toLocaleString() +
            '</b> &nbsp;·&nbsp; Currently drawn: <b>' +
            drawn.toLocaleString() +
            '</b> &nbsp;·&nbsp; Window: <b>' +
            this.lastZoomLabel +
            '</b> &nbsp;·&nbsp; Render: <b>' +
            this.lastRenderMs +
            ' ms</b>'
        };

  private rebuild = (): any => {
          var enabled = document.getElementById('toggleReducer').checked
          var targetPoints = parseInt(document.getElementById('targetPoints').value, 10)
  
          this.chartOptions.chart.dataReducer.enabled = enabled
          this.chartOptions.chart.dataReducer.targetPoints = targetPoints
          this.chartOptions.subtitle.text = enabled
            ? 'LTTB downsampling enabled — drawing ~' +
              targetPoints.toLocaleString() +
              ' points'
            : 'Downsampling disabled — drawing every raw point'
  
          var t2 = performance.now()
          this.chart.destroy()
          this.chart = new ApexCharts(document.querySelector('#chart'), this.chartOptions)
          this.chart.render().then(function () {
            this.lastRenderMs = Math.round(performance.now() - t2)
            this.updateStats(this.chart)
          })
        };

  public chartOptions: Partial<ChartOptions> = {
          series: [{ name: 'Sensor reading', data: this.seriesData }],
          chart: {
            height: 460,
            type: 'line',
            animations: { enabled: false },
            zoom: { enabled: true, type: 'x', autoScaleYaxis: true },
            toolbar: { autoSelected: 'zoom' },
            dataReducer: {
              enabled: true,
              algorithm: 'lttb',
              targetPoints: 500,
              threshold: 1000,
            },
            events: {
              zoomed: (chartCtx, args) => {
                var xaxis = args && args.xaxis
                this.lastZoomLabel =
                  xaxis && xaxis.min && xaxis.max
                    ? this.fmt(xaxis.min) + ' → ' + this.fmt(xaxis.max)
                    : 'full range'
                requestAnimationFrame(function () {
                  this.updateStats(chartCtx)
                })
              }        beforeResetZoom: () => {
                this.lastZoomLabel = 'full range'
              },
            },
          },
          stroke: { curve: 'straight', width: 1 },
          dataLabels: { enabled: false },
          markers: { size: 0 },
          title: {
            text: 'Line chart — 500,000 raw datapoints',
            align: 'left',
          },
          subtitle: {
            text: 'LTTB downsampling enabled — zoom in to re-sample the raw series at higher resolution within the visible window',
            align: 'left',
          },
          xaxis: {
            type: 'datetime',
            labels: { datetimeUTC: false },
          },
          yaxis: {
            labels: {
              formatter: (val) => {
                return val.toFixed(2)
              },
            },
          },
          tooltip: { x: { format: 'yyyy-MM-dd HH:mm' } },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');

    var this.chartOptions = {
            series: [{ name: 'Sensor reading', data: this.seriesData }],
            chart: {
              height: 460,
              type: 'line',
              animations: { enabled: false },
              zoom: { enabled: true, type: 'x', autoScaleYaxis: true },
              toolbar: { autoSelected: 'zoom' },
              dataReducer: {
                enabled: true,
                algorithm: 'lttb',
                targetPoints: 500,
                threshold: 1000,
              },
              events: {
                zoomed: (chartCtx, args) => {
                  var xaxis = args && args.xaxis
                  this.lastZoomLabel =
                    xaxis && xaxis.min && xaxis.max
                      ? this.fmt(xaxis.min) + ' → ' + this.fmt(xaxis.max)
                      : 'full range'
                  requestAnimationFrame(function () {
                    this.updateStats(chartCtx)
                  })
                }        beforeResetZoom: () => {
                  this.lastZoomLabel = 'full range'
                },
              },
            },
            stroke: { curve: 'straight', width: 1 },
            dataLabels: { enabled: false },
            markers: { size: 0 },
            title: {
              text: 'Line chart — 500,000 raw datapoints',
              align: 'left',
            },
            subtitle: {
              text: 'LTTB downsampling enabled — zoom in to re-sample the raw series at higher resolution within the visible window',
              align: 'left',
            },
            xaxis: {
              type: 'datetime',
              labels: { datetimeUTC: false },
            },
            yaxis: {
              labels: {
                formatter: (val) => {
                  return val.toFixed(2)
                },
              },
            },
            tooltip: { x: { format: 'yyyy-MM-dd HH:mm' } },
          }
    requestAnimationFrame(() => {
            if (this.chart.chart?.w && this.chart.chart?.w.globals && this.chart.chart?.w.globals.series) {
              this.updateStats(this.chart)
            } else {
              requestAnimationFrame(poll)
            }
          })
    document.getElementById('rerender').addEventListener('click', this.rebuild)
    document.getElementById('toggleReducer').addEventListener('change', this.rebuild)
    document.getElementById('resetZoom').addEventListener('click', () => {
            if (this.chart) this.chart.resetSeries(true, true)
          })
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Large Dataset Downsampling in Vue

Using ApexCharts with Vue

This Large Dataset Downsampling example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div class="panel">
      <div class="controls">
        <label>
          <input type="checkbox" id="toggleReducer" checked />
          Enable LTTB downsampling
        </label>
        <label>
          Target points:
          <input
            type="number"
            id="targetPoints"
            class="target-input"
            value="500"
            min="50"
            max="5000"
            step="50"
          />
        </label>
        <button id="rerender">Re-render</button>
        <button id="resetZoom">Reset zoom</button>
      </div>

      <div class="stats" id="stats"></div>
    </div>

    <div id="chart"></div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'
import ApexCharts from 'apexcharts'

var TOTAL_POINTS = 500000

function generateData(count) {
  var data = new Array(count)
  var startTime = new Date('2010-01-01T00:00:00Z').getTime()
  var step = 60 * 1000 // 1 minute
  var y = 100
  for (var i = 0; i < count; i++) {
    // Random walk with periodic components — gives visible structure at
    // multiple zoom levels (slow trend + faster cycle + noise).
    y +=
      (Math.random() - 0.5) * 2 +
      Math.sin(i / 5000) * 0.05 +
      Math.cos(i / 1200) * 0.02
    data[i] = [startTime + i * step, +y.toFixed(3)]
  }
  return data
}

var seriesData = generateData(TOTAL_POINTS)
var lastRenderMs = 0
var lastZoomLabel = 'full range'

function fmt(ts) {
  var d = new Date(ts)
  return (
    d.getFullYear() +
    '-' +
    String(d.getMonth() + 1).padStart(2, '0') +
    '-' +
    String(d.getDate()).padStart(2, '0')
  )
}

// Accepts the live chart instance as an argument so the React and Vue builds
// (which have no global `chart` var) can share this stateless helper.
function updateStats(chart) {
  var statsEl = document.getElementById('stats')
  if (!statsEl || !chart || !chart.w) return
  var drawn = (chart.w.globals.series[0] || []).length
  statsEl.innerHTML =
    'Raw points: <b>' +
    TOTAL_POINTS.toLocaleString() +
    '</b> &nbsp;·&nbsp; Currently drawn: <b>' +
    drawn.toLocaleString() +
    '</b> &nbsp;·&nbsp; Window: <b>' +
    lastZoomLabel +
    '</b> &nbsp;·&nbsp; Render: <b>' +
    lastRenderMs +
    ' ms</b>'
}

export default {
components: {
apexchart: VueApexCharts,
},
data: function () {
return {
series: [{ name: 'Sensor reading', data: seriesData }],
chartOptions: {
chart: {
  height: 460,
  type: 'line',
  animations: { enabled: false },
  zoom: { enabled: true, type: 'x', autoScaleYaxis: true },
  toolbar: { autoSelected: 'zoom' },
  dataReducer: {
    enabled: true,
    algorithm: 'lttb',
    targetPoints: 500,
    threshold: 1000,
  },
  events: {
    zoomed: function (chartCtx, args) {
      var xaxis = args && args.xaxis
      lastZoomLabel =
        xaxis && xaxis.min && xaxis.max
          ? fmt(xaxis.min) + ' → ' + fmt(xaxis.max)
          : 'full range'
      requestAnimationFrame(function () {
        updateStats(chartCtx)
      })
    },
    beforeResetZoom: function () {
      lastZoomLabel = 'full range'
    },
  },
},
stroke: { curve: 'straight', width: 1 },
dataLabels: { enabled: false },
markers: { size: 0 },
title: {
  text: 'Line chart — 500,000 raw datapoints',
  align: 'left',
},
subtitle: {
  text: 'LTTB downsampling enabled — zoom in to re-sample the raw series at higher resolution within the visible window',
  align: 'left',
},
xaxis: {
  type: 'datetime',
  labels: { datetimeUTC: false },
},
yaxis: {
  labels: {
    formatter: function (val) {
      return val.toFixed(2)
    },
  },
},
tooltip: { x: { format: 'yyyy-MM-dd HH:mm' } },
},
reducerChart: null,
reducerDisposed: false,
}
},
mounted: function () {
  // This demo destroys and recreates the chart imperatively on every re-render,
  // so it skips the vue-apexcharts wrapper and creates the instance in #chart
  // directly, exactly like the vanilla build. TOTAL_POINTS, seriesData, fmt,
  // updateStats and the lastRenderMs / lastZoomLabel state live in the shared
  // head script.
  var me = this
  var chart = null

  // The vanilla build gets a mutable `options` global from the template; rebuild
  // it here from the parsed chart state.
  var options = Object.assign({ series: me.series }, me.chartOptions)
  options.chart = Object.assign({}, me.chartOptions.chart)
  options.chart.dataReducer = Object.assign({}, me.chartOptions.chart.dataReducer)

  function rebuild() {
    var enabled = document.getElementById('toggleReducer').checked
    var targetPoints = parseInt(
      document.getElementById('targetPoints').value,
      10,
    )

    options.chart.dataReducer.enabled = enabled
    options.chart.dataReducer.targetPoints = targetPoints
    options.subtitle.text = enabled
      ? 'LTTB downsampling enabled — drawing ~' +
        targetPoints.toLocaleString() +
        ' points'
      : 'Downsampling disabled — drawing every raw point'

    var t2 = performance.now()
    if (chart) chart.destroy()
    chart = new ApexCharts(document.querySelector('#chart'), options)
    me.reducerChart = chart
    chart.render().then(function () {
      if (me.reducerDisposed) return
      lastRenderMs = Math.round(performance.now() - t2)
      updateStats(chart)
    })
  }

  document.getElementById('rerender').addEventListener('click', rebuild)
  document.getElementById('toggleReducer').addEventListener('change', rebuild)
  document.getElementById('resetZoom').addEventListener('click', function () {
    if (chart) chart.resetSeries(true, true)
  })

  // Initial render into #chart, then seed the stats once the first paint settles.
  chart = new ApexCharts(document.querySelector('#chart'), options)
  me.reducerChart = chart
  chart.render().then(function () {
    if (me.reducerDisposed) return
    updateStats(chart)
  })
},
beforeDestroy: function () {
  this.reducerDisposed = true
  if (this.reducerChart) this.reducerChart.destroy()
},,
}
</script>

<style>
#chart {
  max-width: 1000px;
  margin: 20px auto;
}
.panel {
  max-width: 1000px;
  margin: 16px auto;
  font-family: sans-serif;
}
.controls {
  display: flex;
  gap: 14px;
  align-items: center;
  flex-wrap: wrap;
  margin-bottom: 8px;
}
.controls label {
  font-size: 14px;
}
.controls button {
  padding: 6px 14px;
  cursor: pointer;
}
.target-input {
  width: 80px;
}
.stats {
  font-family: monospace;
  font-size: 13px;
  color: #555;
  line-height: 1.6;
}
.stats b {
  color: #111;
}
.note {
  background: #f4f8ff;
  border-left: 3px solid #5b8cff;
  padding: 10px 14px;
  font-size: 13px;
  color: #234;
  margin-top: 10px;
  border-radius: 2px;
}
</style>

Large Dataset Downsampling in React

Using ApexCharts with React

This Large Dataset Downsampling example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import ApexCharts from 'apexcharts'
import './styles.css'

var TOTAL_POINTS = 500000

function generateData(count) {
  var data = new Array(count)
  var startTime = new Date('2010-01-01T00:00:00Z').getTime()
  var step = 60 * 1000 // 1 minute
  var y = 100
  for (var i = 0; i < count; i++) {
    // Random walk with periodic components — gives visible structure at
    // multiple zoom levels (slow trend + faster cycle + noise).
    y +=
      (Math.random() - 0.5) * 2 +
      Math.sin(i / 5000) * 0.05 +
      Math.cos(i / 1200) * 0.02
    data[i] = [startTime + i * step, +y.toFixed(3)]
  }
  return data
}

var seriesData = generateData(TOTAL_POINTS)
var lastRenderMs = 0
var lastZoomLabel = 'full range'

function fmt(ts) {
  var d = new Date(ts)
  return (
    d.getFullYear() +
    '-' +
    String(d.getMonth() + 1).padStart(2, '0') +
    '-' +
    String(d.getDate()).padStart(2, '0')
  )
}

// Accepts the live chart instance as an argument so the React and Vue builds
// (which have no global `chart` var) can share this stateless helper.
function updateStats(chart) {
  var statsEl = document.getElementById('stats')
  if (!statsEl || !chart || !chart.w) return
  var drawn = (chart.w.globals.series[0] || []).length
  statsEl.innerHTML =
    'Raw points: <b>' +
    TOTAL_POINTS.toLocaleString() +
    '</b> &nbsp;·&nbsp; Currently drawn: <b>' +
    drawn.toLocaleString() +
    '</b> &nbsp;·&nbsp; Window: <b>' +
    lastZoomLabel +
    '</b> &nbsp;·&nbsp; Render: <b>' +
    lastRenderMs +
    ' ms</b>'
}

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [{ name: 'Sensor reading', data: seriesData }],
    options: {
      chart: {
        height: 460,
        type: 'line',
        animations: { enabled: false },
        zoom: { enabled: true, type: 'x', autoScaleYaxis: true },
        toolbar: { autoSelected: 'zoom' },
        dataReducer: {
          enabled: true,
          algorithm: 'lttb',
          targetPoints: 500,
          threshold: 1000,
        },
        events: {
          zoomed: function (chartCtx, args) {
            var xaxis = args && args.xaxis
            lastZoomLabel =
              xaxis && xaxis.min && xaxis.max
                ? fmt(xaxis.min) + ' → ' + fmt(xaxis.max)
                : 'full range'
            requestAnimationFrame(function () {
              updateStats(chartCtx)
            })
          },
          beforeResetZoom: function () {
            lastZoomLabel = 'full range'
          },
        },
      },
      stroke: { curve: 'straight', width: 1 },
      dataLabels: { enabled: false },
      markers: { size: 0 },
      title: {
        text: 'Line chart — 500,000 raw datapoints',
        align: 'left',
      },
      subtitle: {
        text: 'LTTB downsampling enabled — zoom in to re-sample the raw series at higher resolution within the visible window',
        align: 'left',
      },
      xaxis: {
        type: 'datetime',
        labels: { datetimeUTC: false },
      },
      yaxis: {
        labels: {
          formatter: function (val) {
            return val.toFixed(2)
          },
        },
      },
      tooltip: { x: { format: 'yyyy-MM-dd HH:mm' } },
    },
  })

  React.useEffect(() => {
    // This demo destroys and recreates the chart imperatively on every re-render,
    // so it skips the react-apexcharts wrapper and creates the instance in #chart
    // directly, exactly like the vanilla build. TOTAL_POINTS, seriesData, fmt,
    // updateStats and the lastRenderMs / lastZoomLabel state live in the shared
    // head script.
    let chart = null
    let disposed = false

    // The vanilla build gets a mutable `options` global from the template; rebuild
    // it here from the parsed chart state.
    const options = Object.assign({ series: state.series }, state.options)
    options.chart = Object.assign({}, state.options.chart)
    options.chart.dataReducer = Object.assign(
      {},
      state.options.chart.dataReducer,
    )

    function rebuild() {
      const enabled = document.getElementById('toggleReducer').checked
      const targetPoints = parseInt(
        document.getElementById('targetPoints').value,
        10,
      )

      options.chart.dataReducer.enabled = enabled
      options.chart.dataReducer.targetPoints = targetPoints
      options.subtitle.text = enabled
        ? 'LTTB downsampling enabled — drawing ~' +
          targetPoints.toLocaleString() +
          ' points'
        : 'Downsampling disabled — drawing every raw point'

      const t2 = performance.now()
      if (chart) chart.destroy()
      chart = new ApexCharts(document.querySelector('#chart'), options)
      chart.render().then(function () {
        if (disposed) return
        lastRenderMs = Math.round(performance.now() - t2)
        updateStats(chart)
      })
    }

    document.getElementById('rerender').addEventListener('click', rebuild)
    document.getElementById('toggleReducer').addEventListener('change', rebuild)
    document.getElementById('resetZoom').addEventListener('click', function () {
      if (chart) chart.resetSeries(true, true)
    })

    // Initial render into #chart, then seed the stats once the first paint settles.
    chart = new ApexCharts(document.querySelector('#chart'), options)
    chart.render().then(function () {
      if (disposed) return
      updateStats(chart)
    })

    return () => {
      disposed = true
      if (chart) chart.destroy()
    }
  }, [])

  return (
    <div>
      <div className="panel">
        <div className="controls">
          <label>
            <input type="checkbox" id="toggleReducer" checked />
            Enable LTTB downsampling
          </label>
          <label>
            Target points:
            <input
              type="number"
              id="targetPoints"
              className="target-input"
              value="500"
              min="50"
              max="5000"
              step="50"
            />
          </label>
          <button id="rerender">Re-render</button>
          <button id="resetZoom">Reset zoom</button>
        </div>

        <div className="stats" id="stats"></div>
      </div>

      <div id="chart"></div>
    </div>
  )
}

export default ApexChart